glibmm: Gio::AsyncInitable Class Reference

glibmm 2.38.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::AsyncInitable Class Reference

AsyncInitable - Asynchronously failable object initialization interface. More...

`#include <giomm/asyncinitable.h>`

Inheritance diagram for Gio::AsyncInitable:
[legend]

## Public Member Functions
virtual | ~AsyncInitable ()
GAsyncInitable* | gobj ()
| Provides access to the underlying C GObject. More...
const GAsyncInitable* | gobj () const
| Provides access to the underlying C GObject. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject* castitem)
| Called by constructors of derived classes. More...
virtual | ~Interface ()
GObject* | gobj ()
const GObject* | gobj () const
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| AsyncInitable ()
| You should derive from this class to use it. More...
void | init_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Starts asynchronous initialization of the object implementing the interface. More...
void | init_async (const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Non-cancellable version of init_async(). More...
bool | init_finish (const Glib::RefPtr< AsyncResult >& res)
| Finishes asynchronous initialization and returns the result. More...
Glib::RefPtr< Glib::Object > | create_finish (const Glib::RefPtr< AsyncResult >& res)
| Finishes the async construction for the various g_async_initable_new calls, returning the created object or `0` on error. More...
virtual void | init_async_vfunc (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
virtual bool | init_finish_vfunc (const Glib::RefPtr< AsyncResult >& res)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::AsyncInitable > | wrap (GAsyncInitable* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

AsyncInitable - Asynchronously failable object initialization interface.

This is the asynchronous version of Initable; it behaves the same in all ways except that initialization is asynchronous. For more details see the descriptions on Initable.

A class may implement both the Initable and AsyncInitable interfaces.

Users of objects implementing this are not intended to use the interface method directly; instead it will be used automatically in various ways. For C applications you generally just call g_async_initable_new_async() directly, or indirectly via a foo_thing_new_async() wrapper. This will call g_async_initable_init_async() under the cover, calling back with NULL and a set GError on failure.

## Constructor & Destructor Documentation

Gio::AsyncInitable::AsyncInitable | ( |  | ) |
| protected

You should derive from this class to use it.

virtual Gio::AsyncInitable::~AsyncInitable | ( |  | ) |
| virtual

## Member Function Documentation

static void Gio::AsyncInitable::add_interface | ( | GType | gtype_implementer | ) |
| static

Glib::RefPtr<Glib::Object> Gio::AsyncInitable::create_finish | ( | const Glib::RefPtr< AsyncResult >& | res | ) |
| protected

Finishes the async construction for the various g_async_initable_new calls, returning the created object or `0` on error.

Since glibmm 2.22:

Parameters

  res | The AsyncResult from the callback.

Returns
  A newly created Object, or `0` on error. Free with Glib::object_unref().

static GType Gio::AsyncInitable::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GAsyncInitable* Gio::AsyncInitable::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GAsyncInitable* Gio::AsyncInitable::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

void Gio::AsyncInitable::init_async | ( | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |
| protected

Starts asynchronous initialization of the object implementing the interface.

This must be done before any real use of the object after initial construction. If the object also implements Initable you can optionally call Gio::Initable::init() instead.

When the initialization is finished, slot will be called. You can then call init_finish() to get the result of the initialization.

Implementations may also support cancellation. Initialization can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error Gio::IO_ERROR_CANCELLED will be returned. If the object doesn't support cancellable initialization, the error Gio::IO_ERROR_NOT_SUPPORTED will be returned.

If this function is not called, or returns with an error, then all operations on the object should fail, generally returning the error Gio::IO_ERROR_NOT_INITIALIZED.

Implementations of this method must be idempotent: i.e. multiple calls to this function with the same argument should return the same results. Only the first call initializes the object; further calls return the result of the first call. This is so that it's safe to implement the singleton pattern in the GObject constructor function.

For classes that also support the Initable interface, the default implementation of this method will run the Gio::Initable::init() method in a thread, so if you want to support asynchronous initialization via threads, just implement the AsyncInitable interface without overriding any interface methods.

Parameters

  io_priority | The I/O priority of the operation.
  cancellable | Cancellable object to make cancellation possible.
  slot | a SlotAsyncReady to call when the request is satisfied.

Since glibmm 2.28:

void Gio::AsyncInitable::init_async | ( | const SlotAsyncReady& | slot,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |
| protected

Non-cancellable version of init_async().

virtual void Gio::AsyncInitable::init_async_vfunc | ( | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |
| protectedvirtual

bool Gio::AsyncInitable::init_finish | ( | const Glib::RefPtr< AsyncResult >& | res | ) |
| protected

Finishes asynchronous initialization and returns the result.

See g_async_initable_init_async().

Since glibmm 2.22:

Parameters

  res | A AsyncResult.

Returns
  `true` if successful. If an error has occurred, this function will return `false` and set error appropriately if present.

virtual bool Gio::AsyncInitable::init_finish_vfunc | ( | const Glib::RefPtr< AsyncResult >& | res | ) |
| protectedvirtual

Exceptions

  Glib::Errror. |

## Friends And Related Function Documentation

Glib::RefPtr< Gio::AsyncInitable > wrap | ( | GAsyncInitable * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.